
/*
Copyright 2007-2011 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful;
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var EXPORTED_SYMBOLS = [
        /*
         * nsIChannel
         */
        "LOAD_DOCUMENT_URI",
        "LOAD_INITIAL_DOCUMENT_URI",
        "LOAD_REPLACE",

        /*
         * nsIContentPolicy
         */
        "ACCEPT",
        "REJECT_SERVER",
        "TYPE_DOCUMENT",

        /*
         * nsIDOMNode
         */
        "DOCUMENT_NODE",

        /*
         * nsIDOMXPathResult
         */
        "ORDERED_NODE_ITERATOR_TYPE",
        "UNORDERED_NODE_SNAPSHOT_TYPE",

        /*
         * nsIWebProgressListener
         */
        "STATE_REDIRECTING",
        "STATE_STOP",

        /*
         * Services
         */
        "CS",
        "IDNS",
        "IOS",
        "PB",

        /*
         * nsIYarip
         */

        "VERSION",
        "FILE",
        "CHARSET",

        "MODE_PAGE",
        "MODE_FQDN",
        "MODE_SLD",

        "TYPE_WHITELIST",
        "TYPE_BLACKLIST",
        "TYPE_ATTRIBUTE",

        "DATA_TYPE_BOOLEAN",
        "DATA_TYPE_INTEGER",
        "DATA_TYPE_STRING",
        "DATA_TYPE_RESET",

        "INCREMENT_NOT_FOUND",
        "INCREMENT_IGNORED",
        "INCREMENT_FOUND",

        "STATUS_UNKNOWN",
        "STATUS_WHITELISTED",
        "STATUS_BLACKLISTED",
        "STATUS_REDIRECTED",

        "PREF_VERSION",
        "PREF_ENABLED",
        "PREF_FLICKER",
        "PREF_MODE",
        "PREF_INDEX",
        "PREF_ELEMENTS",
        "PREF_EXCLUSIVE",
        "PREF_TEMPLATES",
        "PREF_PRIVATE",
        "PREF_PURGE",
        "PREF_SCHEMES",
        "PREF_PAGES_MODIFIERS",
        "PREF_PAGES_KEY_CODE",
        "PREF_MONITOR_MODIFIERS",
        "PREF_MONITOR_KEY_CODE",
        "PREF_RECURRENCE",
        "PREF_LOG_WHEN_CLOSED",

        "OUTLINE_RE",
        "OUTLINE_END_RE"
    ];

const Cc = Components.classes;
const Ci = Components.interfaces;
//const Cr = Components.results;
//const Cu = Components.utils;

/*
 * nsIChannel
 */
const LOAD_DOCUMENT_URI = Ci.nsIChannel.LOAD_DOCUMENT_URI;
const LOAD_INITIAL_DOCUMENT_URI = Ci.nsIChannel.LOAD_INITIAL_DOCUMENT_URI;
const LOAD_REPLACE = Ci.nsIChannel.LOAD_REPLACE;

/*
 * nsIContentPolicy
 */
const ACCEPT = Ci.nsIContentPolicy.ACCEPT;
const REJECT_SERVER = Ci.nsIContentPolicy.REJECT_SERVER;
const TYPE_DOCUMENT = Ci.nsIContentPolicy.TYPE_DOCUMENT;

/*
 * nsIDOMNode
 */
const DOCUMENT_NODE = Ci.nsIDOMNode.DOCUMENT_NODE;

/*
 * nsIDOMXPathResult
 */
const ORDERED_NODE_ITERATOR_TYPE = Ci.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE;
const UNORDERED_NODE_SNAPSHOT_TYPE = Ci.nsIDOMXPathResult.UNORDERED_NODE_SNAPSHOT_TYPE;

/*
 * nsIWebProgressListener
 */
const STATE_REDIRECTING = Ci.nsIWebProgressListener.STATE_REDIRECTING;
const STATE_STOP = Ci.nsIWebProgressListener.STATE_STOP;

/*
 * Services
 */
const CS = Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService);
const IDNS = Cc["@mozilla.org/network/idn-service;1"].getService(Ci.nsIIDNService);
const IOS = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
const PB = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);

/*
 * nsIYarip
 */

const VERSION = "0.3.1";
const FILE = "yarip.xml";
const CHARSET = "UTF-8";

const MODE_PAGE = 0;
const MODE_FQDN = 1;
const MODE_SLD = 2;

const TYPE_WHITELIST = 0;
const TYPE_BLACKLIST = 1;
const TYPE_ATTRIBUTE = 2;

const DATA_TYPE_BOOLEAN = 0;
const DATA_TYPE_INTEGER = 1;
const DATA_TYPE_STRING = 2;
const DATA_TYPE_RESET = 3;

const INCREMENT_NOT_FOUND = 0;
const INCREMENT_IGNORED = 1;
const INCREMENT_FOUND = 2;

const STATUS_UNKNOWN = 0;
const STATUS_WHITELISTED = 1;
const STATUS_BLACKLISTED = 2;
const STATUS_REDIRECTED = 3;

const PREF_VERSION = "extensions.yarip.version";
const PREF_ENABLED = "extensions.yarip.enabled.value";
const PREF_FLICKER = "extensions.yarip.noFlicker.value";
const PREF_MODE = "extensions.yarip.mode.value";
const PREF_INDEX = "extensions.yarip.alwaysUseIndex.value";
const PREF_ELEMENTS = "extensions.yarip.elementsInContext.value";
const PREF_EXCLUSIVE = "extensions.yarip.exclusiveOnCreation.value";
const PREF_TEMPLATES = "extensions.yarip.templatesList.value";
const PREF_PRIVATE = "extensions.yarip.privateBrowsing.value";
const PREF_PURGE = "extensions.yarip.purgeInnerHTML.value";
const PREF_SCHEMES = "extensions.yarip.schemesRegExp.value";
const PREF_PAGES_MODIFIERS = "extensions.yarip.managePagesModifiersList.value";
const PREF_PAGES_KEY_CODE = "extensions.yarip.managePagesKeyCode.value";
const PREF_MONITOR_MODIFIERS = "extensions.yarip.monitorContentModifiersList.value";
const PREF_MONITOR_KEY_CODE = "extensions.yarip.monitorContentKeyCode.value";
//const PREF_REPEAT = "extensions.yarip.contentRepeatThreshold.value";
const PREF_RECURRENCE = "extensions.yarip.contentRecurrence.value";
const PREF_LOG_WHEN_CLOSED = "extensions.yarip.logWhenClosed.value";

const OUTLINE_RE = /^outline-color:\ rgb\((0|153),\ 0,\ (0|153)\);\ outline-style:\ solid;\ outline-width:\ 3px;$/;
const OUTLINE_END_RE = /outline-color:\ rgb\((0|153),\ 0,\ (0|153)\);\ outline-style:\ solid;\ outline-width:\ 3px;$/;

