
/*
Copyright 2007-2011 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

const EXPORTED_SYMBOLS = ["YaripObject"];

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;
const Cu = Components.utils;

const yarip = Cu.import("resource://yarip/yarip.jsm", null).wrappedJSObject;
Cu.import("resource://yarip/constants.jsm");
Cu.import("resource://yarip/uri.jsm");

function YaripObject() {
}
YaripObject.prototype = {
    newId: function()
    {
        return yarip.getId();
    },

    getRegExp: function(value)
    {
        switch (value) {
        case "uriSimple": return URI_SIMPLE_RE;
        case "findTld": return FIND_TLD_RE;
        }
    },

    getPageById: function(id)
    {
        return yarip.map.getById(id);
    },

    checkXPath: function(value)
    {
        return yarip.checkXPath(value);
    },

    checkRegExp: function(value)
    {
        return yarip.checkRegExp(value);
    }
}

